from abc import ABC, abstractmethod

# Definition des Interfaces für den StringCalculator
class IStringCalculator(ABC):
    @abstractmethod
    def add(self, numbers: str) -> int:
        """
        Addiert beliebig viele Zahlen, die durch Kommas getrennt sind.
        Leere oder nur aus Leerzeichen bestehende Einträge werden ignoriert.

        :param numbers: String mit Zahlen (z.B. "1,2,3")
        :return: Summe der Zahlen als int
        """
        pass

class ICounter(ABC):
    @abstractmethod
    def count_ed(self, s: str) -> int:
        """Zählt die Buchstaben 'E' und 'D' in einem String (Case-Insensitive)."""
        pass
class IRomanConverter(ABC):
    @abstractmethod
    def roman_to_int(self, s: str) -> int:
        """Konvertiert eine römische Zahl (String) in eine Dezimalzahl."""
        pass

class ICalculator(ABC):
    @abstractmethod
    def calculate(self, expression: str) -> float:
        pass